/*
 * Copyright (c) 2002-2006 - Aleksander Naszko, Julien Laurent
 *
 *    This file is part of AMX Mod.
 *
 *    AMX Mod is free software; you can redistribute it and/or modify it
 *    under the terms of the GNU General Public License as published by the
 *    Free Software Foundation; either version 2 of the License, or (at
 *    your option) any later version.
 *
 *    AMX Mod is distributed in the hope that it will be useful, but
 *    WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with AMX Mod; if not, write to the Free Software Foundation,
 *    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    In addition, as a special exception, the author gives permission to
 *    link the code of this program with the Half-Life Game Engine ("HL
 *    Engine") and Modified Game Libraries ("MODs") developed by Valve,
 *    L.L.C ("Valve").  You must obey the GNU General Public License in all
 *    respects for all of the code used other than the HL Engine and MODs
 *    from Valve.  If you modify this file, you may extend this exception
 *    to your version of the file, but you are not obligated to do so.  If
 *    you do not wish to do so, delete this exception statement from your
 *    version.
 *
 */

/*
 * A part of the code is from Ludwig Van's admin chat deluxe plugin.
 * Credit for fxsay and flicksay goes to NiLuJe.
 *
 *
 */
 
#include <translator>
#include <amxmod>
#include <amxmisc>

#define HOLDTIME 8.0

#define MAX_CLR 16

new g_Colors[MAX_CLR][] = {"!","?","white","red","green","blue","yellow","magenta","cyan","w","r","g","b","y","m","c"}
new g_Values[MAX_CLR][] = {{255,255,255},{255,255,255},{255,255,255},{255,0,0},{0,255,0},{0,0,255},{255,255,0},{255,0,255},{0,255,255},{255,255,255},{255,0,0},{0,255,0},{0,0,255},{255,255,0},{255,0,255},{0,255,255}}

#define SCROLL_SPEED 0.3

new sc_msgChannel
new sc_start_pos
new sc_end_pos
new sc_scroll_msg[384]
new sc_display_msg[384]
new Float:sc_x_pos
new sc_a
new sc_timer
new sc_length

new g_logFile[16]
new g_msgChannel

public plugin_init() {
  load_translations("adminchat")
  register_plugin(_T("Admin Chat"),AMX_VERSION,"AMX Team")
  register_clcmd("say_team","cmdSayAdmin",0,_T("@<message> - displays message to admins"))
  register_clcmd("say","cmdSayChat",ADMIN_CHAT,_T("<@[@|@]|#[#|#]|$[$|$]>[color] <message> - displays hud message"))
  register_concmd("amx_say","cmdSay",ADMIN_CHAT,_T("<message> - sends message to all players"))
  register_concmd("amx_sayy","cmdSay",ADMIN_CHAT,_T("<message> - sends message to all players - anonymous"))
  register_concmd("amx_chat","cmdChat",ADMIN_CHAT,_T("<message> - sends message to admins"))
  register_concmd("amx_psay","cmdPsay",ADMIN_CHAT,_T("<name|#userid|authid> <message> - sends private message"))
  register_concmd("amx_psayy","cmdPsay",ADMIN_CHAT,_T("<name|#userid|authid> <message> - sends private message - anonymous"))
  register_concmd("amx_tsay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends left side hud message to all players"))
  register_concmd("amx_tsayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends left side hud message to all players - anonymous"))
  register_concmd("amx_csay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center hud message to all players"))
  register_concmd("amx_csayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center hud message to all players - anonymous"))
  register_concmd("amx_fxsay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends fx hud message to all players"))
  register_concmd("amx_cfxsay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center fx hud message to all players"))
  register_concmd("amx_fxsayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends fx hud message to all players - anonymous"))
  register_concmd("amx_cfxsayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center fx hud message to all players - anonymous"))
  register_concmd("amx_flicksay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends flickering hud message to all players"))
  register_concmd("amx_cflicksay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center flickering hud message to all players"))
  register_concmd("amx_flicksayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends flickering hud message to all players - anonymous"))
  register_concmd("amx_cflicksayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center flickering hud message to all players - anonymous"))
  register_concmd("amx_fsay","cmdFsay",ADMIN_CHAT,_T("<x position 0-99> <y position 0-99> [color] <message> - sends hud message to all players"))
  register_concmd("amx_fsayy","cmdFsay",ADMIN_CHAT,_T("<x position 0-99> <y position 0-99> [color] <message> - sends hud message to all players - anonymous"))
  register_concmd("amx_scrollsay","cmdScrollsay",ADMIN_CHAT,_T("[color] <message> - sends scroll message to all players"))
  register_concmd("amx_scrollsayy","cmdScrollsay",ADMIN_CHAT,_T("[color] <message> - sends scroll message to all players - anonymous"))
  register_concmd("psay","cmdPsay",ADMIN_CHAT,_T("<name|#userid|authid> <message> - sends private message"))
  register_concmd("psayy","cmdPsay",ADMIN_CHAT,_T("<name|#userid|authid> <message> - sends private message - anonymous"))
  register_concmd("tsay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends left side hud message to all players"))
  register_concmd("tsayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends left side hud message to all players - anonymous"))
  register_concmd("csay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center hud message to all players"))
  register_concmd("csayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center hud message to all players - anonymous"))
  register_concmd("fxsay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends fx hud message to all players"))
  register_concmd("cfxsay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center fx hud message to all players"))
  register_concmd("fxsayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends fx hud message to all players - anonymous"))
  register_concmd("cfxsayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center fx hud message to all players - anonymous"))
  register_concmd("flicksay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends flickering hud message to all players"))
  register_concmd("cflicksay","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center flickering hud message to all players"))
  register_concmd("flicksayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends flickering hud message to all players - anonymous"))
  register_concmd("cflicksayy","cmdTsay",ADMIN_CHAT,_T("[color] <message> - sends center flickering hud message to all players - anonymous"))
  register_concmd("fsay","cmdFsay",ADMIN_CHAT,_T("<x position 0-99> <y position 0-99> [color] <message> - sends hud message to all players"))
  register_concmd("fsayy","cmdFsay",ADMIN_CHAT,_T("<x position 0-99> <y position 0-99> [color] <message> - sends hud message to all players - anonymous"))
  register_concmd("scrollsay","cmdScrollsay",ADMIN_CHAT,_T("[color] <message> - sends scroll message to all players"))
  register_concmd("scrollsayy","cmdScrollsay",ADMIN_CHAT,_T("[color] <message> - sends scroll message to all players - anonymous"))
  get_logfile(g_logFile, 15)
}

public cmdSayChat(id) { 
  if(!(get_user_flags(id) & ADMIN_CHAT)) 
    return PLUGIN_CONTINUE 

  new message[192]
  read_args(message, 191)
  replace_all(message, 191, "^"", "")

  if(equal(message, "@@@", 3)) {
    client_cmd(id, "amx_scrollsayy %s", message[3])
    return PLUGIN_HANDLED
  }
  else if(equal(message, "@@", 2)) {
    client_cmd(id, "amx_csayy %s", message[2])
    return PLUGIN_HANDLED
  }
  else if(equal(message, "@", 1)) {
    client_cmd(id, "amx_tsayy %s", message[1])
    return PLUGIN_HANDLED
  }
  else if(equal(message, "###", 3)) {
    client_cmd(id, "amx_sayy %s", message[3])
    return PLUGIN_HANDLED
  }
  else if(equal(message, "##", 2)) {
    client_cmd(id, "amx_chat %s", message[2])
    return PLUGIN_HANDLED
  }
  else if(equal(message, "#", 1)) {
    client_cmd(id, "amx_psayy %s", message[1])
    return PLUGIN_HANDLED
  }
  else if(equal(message, "$$$", 3)) {
    client_cmd(id, "amx_fsayy %s", message[3])
    return PLUGIN_HANDLED
  }
  else if(equal(message, "$$", 2)) {
    client_cmd(id, "amx_flicksayy %s", message[2])
    return PLUGIN_HANDLED
  }
  else if(equal(message, "$", 1)) {
    client_cmd(id, "amx_fxsayy %s", message[1])
    return PLUGIN_HANDLED
  }
  return PLUGIN_CONTINUE
}

public cmdSayAdmin(id) { 
  new said[2]
  read_argv(1, said, 1) 
  if(said[0] != '@') return PLUGIN_CONTINUE
  new message[192], name[32], authid[32], userid
  new players[32], inum
  read_args(message, 191)
  replace_all(message, 191, "^"", "")
  get_user_authid(id, authid, 31)
  get_user_name(id, name, 31)
  userid = get_user_userid(id)
  log_to_file(g_logFile,"Chat: ^"%s<%d><%s><>^" chat ^"%s^"",name,userid,authid,message[1])
  log_message("^"%s<%d><%s><>^" triggered ^"amx_chat^" (text ^"%s^")",name,userid,authid,message[1])
  new isAdmin = is_user_admin(id)
  get_players(players, inum, "c")
  for(new i = 0; i < inum; ++i) {
    if(players[i] == id || get_user_flags(players[i]) & ADMIN_CHAT) {
      switch(isAdmin) {
        case 1 : client_print(players[i], print_chat, _T("(ADMIN) %s :  %s"), name, message[1])
        default: client_print(players[i], print_chat, _T("(PLAYER) %s :  %s"), name, message[1])
      }
    }
  }
  return PLUGIN_HANDLED
}

public cmdChat(id,level,cid) {
  if(!cmd_access(id,level,cid,2))
    return PLUGIN_HANDLED

  new message[192], name[32], players[32], inum, authid[32], userid
  read_args(message, 191)
  replace_all(message, 191, "^"", "")
  get_user_authid(id, authid, 31)
  get_user_name(id, name, 31)
  userid = get_user_userid(id)
  get_players(players, inum, "c")
  log_to_file(g_logFile,"Chat: ^"%s<%d><%s><>^" chat ^"%s^"",name,userid,authid,message)
  log_message("^"%s<%d><%s><>^" triggered ^"amx_chat^" (text ^"%s^")",name,userid,authid,message)
  console_print(id, message)
  for(new i = 0; i < inum; ++i) {
    if(get_user_flags(players[i]) & ADMIN_CHAT)
      client_print(players[i], print_chat, _T("(ADMINS) %s :  %s"), name, message)
  }
  return PLUGIN_HANDLED
}

public cmdSay(id,level,cid) {
  if(!cmd_access(id,level,cid,2))
    return PLUGIN_HANDLED

  new cmd[16]
  read_argv(0, cmd, 15)
  new message[192], name[32], authid[32], userid
  read_args(message, 191)
  replace_all(message, 191, "^"", "")
  get_user_authid(id, authid, 31)
  get_user_name(id, name, 31)
  userid = get_user_userid(id)
  
  if(containi(cmd, "yy") == -1 || get_cvar_num("amx_show_activity") == 2) {
    client_print(0, print_chat, _T("(ALL) %s :  %s"), name, message)
  }
  else {
    client_print(0, print_chat, _T("(ALL) ADMIN :  %s"), message)
  }
  
  console_print(id, _T("(ALL) %s :  %s"), name, message)
  log_to_file(g_logFile,"Chat: ^"%s<%d><%s><>^" say ^"%s^"",name,userid,authid,message)
  log_message("^"%s<%d><%s><>^" triggered ^"amx_say^" (text ^"%s^")",name,userid,authid,message)
  return PLUGIN_HANDLED
}

public cmdPsay(id,level,cid) {
  if(!cmd_access(id,level,cid,3))
    return PLUGIN_HANDLED

  new cmd[16]
  read_argv(0, cmd, 15)
  new name[32]
  read_argv(1, name, 31)
  new priv = cmd_target(id, name, 0)
  if(!priv) return PLUGIN_HANDLED
  new length = strlen(name) + 1
  new message[192], name2[32], authid[32], authid2[32], userid, userid2
  get_user_authid(id, authid, 31)
  get_user_name(id, name2, 31)
  userid = get_user_userid(id)
  read_args(message, 191)
  if(message[0] == '"' && message[length] == '"') { // HLSW fix
    message[0] = ' '
    message[length] = ' '
    length += 2
  }
  replace_all(message[length], 191-length, "^"", "")
  get_user_name(priv, name, 31)
  
  if(containi(cmd, "yy") == -1 || get_cvar_num("amx_show_activity") == 2) {
    if(id && id != priv) client_print(id, print_chat, "(%s) %s :  %s", name, name2, message[length])
    client_print(priv, print_chat, "(%s) %s :  %s", name, name2, message[length])
  }
  else {
    if(id && id != priv) client_print(id, print_chat, "(%s) %s :  %s", name, name2, message[length])
    client_print(priv, print_chat, _T("(%s) ADMIN :  %s"), name, message[length])
  }

  console_print(id, "(%s) %s :  %s", name, name2, message[length])
  get_user_authid(priv, authid2, 31)
  userid2 = get_user_userid(priv)
  log_to_file(g_logFile,"Chat: ^"%s<%d><%s><>^" psay ^"%s<%d><%s><>^" ^"%s^"",
      name2,userid,authid,name,userid2,authid2,message[length])
  log_message("^"%s<%d><%s><>^" triggered ^"amx_psay^" against ^"%s<%d><%s><>^" (text ^"%s^")",
    name2,userid,authid,name,userid2,authid2,message[length])
  return PLUGIN_HANDLED
}

public cmdTsay(id,level,cid) {
  if(!cmd_access(id,level,cid,2))
    return PLUGIN_HANDLED

  new cmd[16], color[12], message[192], name[32], authid[32], userid = 0
  read_argv(0, cmd, 15)
  read_args(message, 191)
  parse(message, color, 11)
  new found = 0, a = 0
  if(equal(color, "!", 1)) {
    a = 0
    found = 1
    new sred[4], sgreen[4], sblue[4], ired, igreen, iblue
    if(strlen(color) < 2) {
      g_Values[0][0] = 255
      g_Values[0][1] = 255
      g_Values[0][2] = 255
    }
    else {
      copy(sred, 3, color[1])
      copy(sgreen, 3, color[4])
      copy(sblue, 3, color[7])
      ired = str_to_num(sred)
      igreen = str_to_num(sgreen)
      iblue = str_to_num(sblue)
      if(ired < 0 || ired > 255)
        ired = 255
      if(igreen < 0 || igreen > 255)
        igreen = 255
      if(iblue < 0 || iblue > 255)
        iblue = 255
      g_Values[0][0] = ired
      g_Values[0][1] = igreen
      g_Values[0][2] = iblue
    }
  }
  else if(equal(color, "?")) {
    a = 1
    found = 1
    g_Values[1][0] = random_num(32,255)
    g_Values[1][1] = random_num(32,255)
    g_Values[1][2] = random_num(32,255)
  }
  else {
    for(new i = 2; i < MAX_CLR; ++i) {
      if(equali(color, _T(g_Colors[i], id)) || equali(color, g_Colors[i])) {
        a = i
        found = 1
        break
      }
    }
  }
  if(!found) a = 2
  
  new length = found ? (strlen(color) + 1) : 0
  if(++g_msgChannel > 6 || g_msgChannel < 3)
    g_msgChannel = 3
  get_user_authid(id, authid, 31)
  get_user_name(id, name, 31)
  userid = get_user_userid(id)

  if(equali(cmd, "tsay", 4) || equali(cmd[4], "tsay", 4))
    set_hudmessage(g_Values[a][0], g_Values[a][1], g_Values[a][2], 0.05, 0.55+float(g_msgChannel)/35.0, 0, 6.0, HOLDTIME, 0.5, 0.15, g_msgChannel)
  else if(equali(cmd, "csay", 4) || equali(cmd[4], "csay", 4))
    set_hudmessage(g_Values[a][0], g_Values[a][1], g_Values[a][2], -1.0, 0.1+float(g_msgChannel)/35.0, 0, 6.0, HOLDTIME, 0.5, 0.15, g_msgChannel)
  else if(equali(cmd, "fxsay", 5) || equali(cmd[4], "fxsay", 5))
    set_hudmessage(g_Values[a][0], g_Values[a][1], g_Values[a][2], 0.05, 0.55+float(g_msgChannel)/35.0, 2, 0.25, HOLDTIME, 0.05, 1.0, g_msgChannel)
  else if(equali(cmd, "cfxsay", 6) || equali(cmd[4], "cfxsay", 6))
    set_hudmessage(g_Values[a][0], g_Values[a][1], g_Values[a][2], -1.0, 0.1+float(g_msgChannel)/35.0, 2, 0.25, HOLDTIME, 0.05, 1.0, g_msgChannel)
  else if(equali(cmd, "flicksay", 8) || equali(cmd[4], "flicksay", 8))
    set_hudmessage(g_Values[a][0], g_Values[a][1], g_Values[a][2], 0.05, 0.55+float(g_msgChannel)/35.0, 1, 6.0, HOLDTIME, 0.5, 0.2, g_msgChannel)
  else if(equali(cmd, "cflicksay", 9) || equali(cmd[4], "cflicksay", 9))
    set_hudmessage(g_Values[a][0], g_Values[a][1], g_Values[a][2], -1.0, 0.1+float(g_msgChannel)/35.0, 1, 6.0, HOLDTIME, 0.5, 0.2, g_msgChannel)

  replace_all(message[length], 191-length, "^"", "")
  replace_all(message[length], 191-length, "^^n", "^n")
  if(containi(cmd, "yy") == -1 || get_cvar_num("amx_show_activity") == 2) {
    show_hudmessage(0, "%s :  %s", name, message[length])
    replace_all(message[length], 191-length, "^n", " ")
    client_print(0, print_notify, "%s :  %s", name, message[length])
  }
  else {
    show_hudmessage(0, message[length])
    replace_all(message[length], 191-length, "^n", " ")
    client_print(0, print_notify, message[length])
  }

  log_to_file(g_logFile,"Chat: ^"%s<%d><%s><>^" %s ^"%s^"",name,userid,authid,cmd,message[length])
  log_message("^"%s<%d><%s><>^" triggered ^"%s^" (text ^"%s^") (color ^"%s^")",
    name,userid,authid,cmd,message[length],g_Colors[a])
  return PLUGIN_HANDLED
}

public cmdFsay(id,level,cid) {
  if(!cmd_access(id,level,cid,4))
    return PLUGIN_HANDLED

  new cmd[16], x_pos[8], y_pos[8], color[12], message[192], name[32], authid[32], userid = 0
  read_argv(0, cmd, 15)
  read_args(message, 191)
  parse(message, x_pos, 7, y_pos, 7, color, 11)
  new len = strlen(x_pos) + 1 + strlen(y_pos) + 1
  new found = 0, a = 0
  if(equal(color, "!", 1)) {
    a = 0
    found = 1
    new sred[4], sgreen[4], sblue[4], ired, igreen, iblue
    if(strlen(color) < 2) {
      g_Values[0][0] = 255
      g_Values[0][1] = 255
      g_Values[0][2] = 255
    }
    else {
      copy(sred, 3, color[1])
      copy(sgreen, 3, color[4])
      copy(sblue, 3, color[7])
      ired = str_to_num(sred)
      igreen = str_to_num(sgreen)
      iblue = str_to_num(sblue)
      if(ired < 0 || ired > 255)
        ired = 255
      if(igreen < 0 || igreen > 255)
        igreen = 255
      if(iblue < 0 || iblue > 255)
        iblue = 255
      g_Values[0][0] = ired
      g_Values[0][1] = igreen
      g_Values[0][2] = iblue
    }
  }
  else if(equal(color, "?")) {
    a = 1
    found = 1
    g_Values[1][0] = random_num(32,255)
    g_Values[1][1] = random_num(32,255)
    g_Values[1][2] = random_num(32,255)
  }
  else {
    for(new i = 2; i < MAX_CLR; ++i) {
      if(equali(color, _T(g_Colors[i], id)) || equali(color, g_Colors[i])) {
        a = i
        found = 1
        break
      }
    }
  }
  if(!found) a = 2
 
  if(equal(x_pos, "-", 1))
    copy(x_pos, 7, "-100")
  new iXpos = str_to_num(x_pos)
  new iYpos = str_to_num(y_pos)
  if(iXpos > 99) iXpos = 99
  if(iYpos < 0)  iYpos = 0
  if(iYpos > 99) iYpos = 99
  new Float:xpos = (iXpos * 0.01)
  new Float:ypos = (iYpos * 0.01)
  new length = found ? (len + strlen(color) + 1) : len
  if(++g_msgChannel > 6 || g_msgChannel < 3)
    g_msgChannel = 3
  get_user_authid(id, authid, 31)
  get_user_name(id, name, 31)
  userid = get_user_userid(id)
  set_hudmessage(g_Values[a][0], g_Values[a][1], g_Values[a][2], xpos, ypos, 0, 6.0, HOLDTIME, 0.5, 0.15, g_msgChannel)

  replace_all(message[length], 191-length, "^"", "")
  replace_all(message[length], 191-length, "^^n", "^n")
  if(containi(cmd, "yy") == -1 || get_cvar_num("amx_show_activity") == 2) {
    show_hudmessage(0, "%s :  %s", name, message[length])
    replace_all(message[length], 191-length, "^n", " ")
    client_print(0, print_notify, "%s :  %s", name, message[length])
  }
  else {
    show_hudmessage(0, message[length])
    replace_all(message[length], 191-length, "^n", " ")
    client_print(0, print_notify, message[length])
  }

  log_to_file(g_logFile,"Chat: ^"%s<%d><%s><>^" %s ^"%s^"",name,userid,authid,cmd,message[length])
  log_message("^"%s<%d><%s><>^" triggered ^"%s^" (text ^"%s^") (color ^"%s^")",
    name,userid,authid,cmd,message[length],g_Colors[a])
  return PLUGIN_HANDLED
}

public cmdScrollsay(id,level,cid) {
  if(!cmd_access(id,level,cid,2))
    return PLUGIN_HANDLED

  if(sc_timer > 0) {
    console_print(id, _T("There is already a scrolling message in progress."))
    return PLUGIN_HANDLED
  }
  new cmd[16], color[12], name[32], authid[32], userid = 0
  read_argv(0, cmd, 15)
  read_args(sc_scroll_msg, 383)
  parse(sc_scroll_msg, color, 11)
  new found = 0
  sc_a = 0
  if(equal(color, "!", 1)) {
    sc_a = 0
    found = 1
    new sred[4], sgreen[4], sblue[4], ired, igreen, iblue
    if(strlen(color) < 2) {
      g_Values[0][0] = 255
      g_Values[0][1] = 255
      g_Values[0][2] = 255
    }
    else {
      copy(sred, 3, color[1])
      copy(sgreen, 3, color[4])
      copy(sblue, 3, color[7])
      ired = str_to_num(sred)
      igreen = str_to_num(sgreen)
      iblue = str_to_num(sblue)
      if(ired < 0 || ired > 255)
        ired = 255
      if(igreen < 0 || igreen > 255)
        igreen = 255
      if(iblue < 0 || iblue > 255)
        iblue = 255
      g_Values[0][0] = ired
      g_Values[0][1] = igreen
      g_Values[0][2] = iblue
    }
  }
  else if(equal(color, "?")) {
    sc_a = 1
    found = 1
    g_Values[1][0] = random_num(32,255)
    g_Values[1][1] = random_num(32,255)
    g_Values[1][2] = random_num(32,255)
  }
  else {
    for(new i = 2; i < MAX_CLR; ++i) {
      if(equali(color, _T(g_Colors[i], id)) || equali(color, g_Colors[i])) {
        sc_a = i
        found = 1
        break
      }
    }
  }
  if(!found) sc_a = 2

  new length = found ? (strlen(color) + 1) : 0
  if(++g_msgChannel > 6 || g_msgChannel < 3)
    g_msgChannel = 3
  sc_msgChannel = g_msgChannel
  sc_end_pos = 1
  sc_start_pos = 0
  sc_x_pos = 0.65
  get_user_authid(id, authid, 31)
  get_user_name(id, name, 31)
  userid = get_user_userid(id)

  replace_all(sc_scroll_msg[length], 383-length, "^"", "")
  if(containi(cmd, "yy") == -1 || get_cvar_num("amx_show_activity") == 2) {
    format(sc_scroll_msg, 383, "%s :  %s", name, sc_scroll_msg[length])
    client_print(0, print_notify, "%s :  %s", name, sc_scroll_msg)
  }
  else {
    format(sc_scroll_msg, 383, sc_scroll_msg[length])
    client_print(0, print_notify, sc_scroll_msg)
  }

  sc_length = strlen(sc_scroll_msg)
  sc_timer = sc_length + 48
  set_task(SCROLL_SPEED, "scroll_msg", 456, "", 0, "a", sc_length + 48)

  log_to_file(g_logFile,"Chat: ^"%s<%d><%s><>^" %s ^"%s^"",name,userid,authid,cmd,sc_scroll_msg)
  log_message("^"%s<%d><%s><>^" triggered ^"%s^" (text ^"%s^") (color ^"%s^")",
    name,userid,authid,cmd,sc_scroll_msg,g_Colors[sc_a])
  return PLUGIN_HANDLED
}

public scroll_msg() {
  sc_timer -= 1
  new b = sc_start_pos, i = 0
  while(b < sc_end_pos) {
    sc_display_msg[i++] = sc_scroll_msg[b++]
  }

  sc_display_msg[i] = 0

  if(sc_end_pos < sc_length)
    sc_end_pos++

  if(sc_x_pos > 0.35)
    sc_x_pos -= 0.0063
  else {
    sc_start_pos++
    sc_x_pos = 0.35
  }
  set_hudmessage(g_Values[sc_a][0], g_Values[sc_a][1], g_Values[sc_a][2], sc_x_pos, 0.90, 0, SCROLL_SPEED, SCROLL_SPEED, 0.05, 0.05, sc_msgChannel)
  show_hudmessage(0, sc_display_msg)
}
